package com.fossgalaxy.games.ggj2017.drones;

import com.fossgalaxy.games.tbs.GameState;
import com.fossgalaxy.games.tbs.actions.RangeAttackAction;
import com.fossgalaxy.games.tbs.entity.Entity;
import com.fossgalaxy.object.annotations.ObjectDef;
import org.codetome.hexameter.core.api.CubeCoordinate;

import java.awt.*;

public class DroneAttackAction extends RangeAttackAction {

    @ObjectDef("DroneAttack")
    public DroneAttackAction() {
        super();
    }

    @Override
    public void renderHints(Graphics2D g, GameState s, Entity actor) {
        if (actor == null || !DroneUtils.rangeHint(g, actor, s)) {
            return;
        }

        super.renderHints(g, s, actor);
    }

    @Override
    public boolean isPossible(Entity entity, GameState s, CubeCoordinate co) {
        if (!DroneUtils.isZoneOfControl(s, entity)) {
            return false;
        }

        return super.isPossible(entity, s, co);
    }

}
