package com.fossgalaxy.games.ggj2017.drones;

import com.fossgalaxy.games.tbs.GameState;
import com.fossgalaxy.games.tbs.actions.BuildOnResourceAction;
import com.fossgalaxy.games.tbs.entity.Entity;
import com.fossgalaxy.games.tbs.order.BuildOrder;
import com.fossgalaxy.games.tbs.order.Order;
import com.fossgalaxy.games.tbs.parameters.EntityType;
import com.fossgalaxy.games.tbs.parameters.ResourceType;
import com.fossgalaxy.object.annotations.ObjectDef;
import org.codetome.hexameter.core.api.CubeCoordinate;

import java.awt.*;

public class DroneBuildResourceAction extends BuildOnResourceAction {

    @ObjectDef("DroneBuildResource")
    public DroneBuildResourceAction(EntityType type, ResourceType rt) {
        super(type, rt);
    }

    @Override
    public void renderHints(Graphics2D g, GameState s, Entity actor) {
        if (actor == null || !DroneUtils.rangeHint(g, actor, s)) {
            return;
        }

        super.renderHints(g, s, actor);
    }

    @Override
    public Order generateOrder(CubeCoordinate co, GameState s) {
        return new BuildOrder(type, co);
    }

    @Override
    public boolean isPossible(Entity entity, GameState s, CubeCoordinate co) {
        if (!DroneUtils.isZoneOfControl(s, entity)) {
            return false;
        }

        return super.isPossible(entity, s, co);
    }

}
